import React from 'react';
import { Tooltip } from '../leafygreen';
import { ItemActionButtonSize } from './constants';
import type { ItemAction, ItemSeparator } from './types';
export type GroupedItemAction<Action extends string> = ItemAction<Action> & {
    tooltipProps?: Parameters<typeof Tooltip>;
};
export type ItemActionGroupProps<Action extends string> = {
    actions: (GroupedItemAction<Action> | ItemSeparator)[];
    onAction(actionName: Action): void;
    isVisible?: boolean;
    /**
     * Called to signal to the parent if the component wants to prevent becoming hidden.
     * Note: In the current implementation, this is called when a menu is opened.
     */
    setHidable?(hidable: boolean): void;
    className?: string;
    iconClassName?: string;
    iconStyle?: React.CSSProperties;
    iconSize?: ItemActionButtonSize;
    'data-testid'?: string;
};
export declare function ItemActionGroup<Action extends string>({ actions, onAction, isVisible, setHidable, className, iconClassName, iconStyle, iconSize, 'data-testid': dataTestId, }: ItemActionGroupProps<Action>): React.JSX.Element | null;
//# sourceMappingURL=item-action-group.d.ts.map