"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CompassGuideCueStorage = void 0;
const GUIDE_CUE_KEY = 'compass_guide_cues';
class CompassGuideCueStorage {
    constructor(storage = globalThis.localStorage, key = GUIDE_CUE_KEY) {
        this.storage = storage;
        this.key = key;
    }
    get data() {
        try {
            return JSON.parse(this.storage.getItem(this.key) ?? '[]');
        }
        catch (e) {
            return [];
        }
    }
    set data(newData) {
        this.storage.setItem(this.key, JSON.stringify(newData));
    }
    isCueVisited(cueId, groupId) {
        return !!this.data.find((x) => x.cueId === cueId && x.groupId === groupId);
    }
    markCueAsVisited(cueId, groupId) {
        if (!this.isCueVisited(cueId, groupId)) {
            const newData = this.data;
            newData.push({ groupId, cueId });
            this.data = newData;
        }
    }
}
exports.CompassGuideCueStorage = CompassGuideCueStorage;
//# sourceMappingURL=guide-cue-storage.js.map