"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.showErrorDetails = void 0;
const use_confirmation_1 = require("./use-confirmation");
const leafygreen_1 = require("../components/leafygreen");
const react_1 = __importDefault(require("react"));
const __1 = require("..");
const showErrorDetails = function showErrorDetails({ details, closeAction, }) {
    void (0, use_confirmation_1.showConfirmation)({
        title: 'Error details',
        description: (react_1.default.createElement(leafygreen_1.Code, { language: "json", "data-testid": "error-details-json", id: "error-details-json" }, JSON.stringify(details, undefined, 2))),
        hideCancelButton: true,
        buttonText: closeAction.replace(/\b\w/g, (c) => c.toUpperCase()),
        confirmButtonProps: {
            variant: __1.ButtonVariant.Default,
        },
    });
};
exports.showErrorDetails = showErrorDetails;
//# sourceMappingURL=use-error-details.js.map