import type React from 'react';
/**
 * Hook that adds support for the grid keyboard navigation while handling the
 * focus using the roving tab index
 *
 * {@link https://www.w3.org/TR/wai-aria-1.1/#grid}
 * {@link https://www.w3.org/TR/wai-aria-1.1/#gridcell}
 * {@link https://www.w3.org/TR/wai-aria-practices-1.1/#kbd_roving_tabindex}
 */
export declare function useVirtualGridArrowNavigation<T extends HTMLElement = HTMLElement>({ colCount, rowCount, itemsCount, resetActiveItemOnBlur, pageSize, defaultCurrentTabbable, onFocusMove, }: {
    colCount: number;
    rowCount: number;
    itemsCount: number;
    resetActiveItemOnBlur?: boolean;
    pageSize?: number;
    defaultCurrentTabbable?: number;
    onFocusMove(idx: number): void;
}): [React.HTMLProps<T>, number];
//# sourceMappingURL=use-virtual-grid.d.ts.map